package cd.casic.ci.common.pipeline;

import cd.casic.ci.common.pipeline.pojo.element.Element;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.jsontype.NamedType;
import com.fasterxml.jackson.databind.module.SimpleModule;
import lombok.extern.slf4j.Slf4j;

import java.util.Map;
import java.util.ServiceLoader;

/**
 * @Author：mianbin
 * @Package：cd.casic.ci.common.pipeline
 * @Project：ops-pro
 * @name：ElementSubTypeRegisterLoader
 * @Date：2025/03/25 17:38
 * @Filename：ElementSubTypeRegisterLoader
 * @description：Todo
 */
@Slf4j
public class ElementSubTypeRegisterLoader {

    public static void registerElementForJsonUtil() {
        registerElement(null);
    }

    public static void registerElement(ObjectMapper objectMapper) {
        Class<ElementSubTypeFetcher> clazz = ElementSubTypeFetcher.class;
        ServiceLoader<ElementSubTypeFetcher> fetcheries = ServiceLoader.load(clazz);

        if (!fetcheries.iterator().hasNext()) {
            fetcheries = ServiceLoader.load(clazz, ServiceLoader.class.getClassLoader());
        }
        SimpleModule elementSubModule = new SimpleModule();
        for (ElementSubTypeFetcher fetcher : fetcheries) {
            log.info("[ELEMENT_FETCHER]| {}", fetcher.getClass());
            Map<String, Class<? extends Element>> jsonSubTypes = fetcher.jsonSubTypes();
            for (Map.Entry<String, Class<? extends Element>> entry : jsonSubTypes.entrySet()) {
                elementSubModule.registerSubtypes(new NamedType(entry.getValue(), entry.getKey()));
                log.info("[REGISTER_MODEL_ELEMENT]|{} for {}", entry.getValue(), entry.getKey());
            }
        }
    }
}

