package cd.casic.ci.common.pipeline.enums;

/**
 * @Classname StyleEnum
 * @Description ops类型枚举
 * @Date 2025/3/18 10:26
 * @author mianbin
 */
public enum BkStyleEnum {
    COMMON_STYLE("^(.|\\r|\\n)*$"),
    NUMBER_STYLE("[0-9]*$"),
    CODE_STYLE("^[a-zA-Z_][\\w-()]{0,31}$"),
    ID_STYLE("^[\\w-]{1,64}$"),
    NAME_STYLE("^[\\w-\\u4E00-\\u9FBB\\u3400-\\u4DBF\\uF900-\\uFAD9\\u3000-\\u303F\\u2000-\\u206F\\uFF00-\\uFFEF.()\\s]{1,40}$"),
    STORE_MEMBER_TYPE_STYLE("^ADMIN|DEVELOPER$"),
    EMAIL_STYLE("^\\w+([-+.]\\w+)*@\\w+([-.]\\w+)*\\.\\w+([-.]\\w+)*$"),
    AUTH_STYLE("^HTTP|HTTPS|OAUTH|SSH$"),
    NOTE_STYLE("^[A-Za-z0-9\\u4E00-\\u9FBB\\u3400-\\u4DBF\\uF900-\\uFAD9\\u3000-\\u303F" +
            "\\u2000-\\u206F\\uFF00-\\uFFEF.。?？！!,()，、；;：:'‘’“”\"…\\s]{1,256}$"),
    VISIBILITY_LEVEL_STYLE("^PRIVATE|LOGIN_PUBLIC$"),
    LANGUAGE_STYLE("^java|python|nodejs|kotilin|golang|c|c++|php|c#$"),
    BOOLEAN_STYLE("^true|false$"),
    SCOPE_STYLE("^TEST|PRD|ALL$"),
    SERVICE_CODE_STYLE("^[a-z][([-a-z-0-9]*[a-z-0-9])?]{0,31}$"),
    BUILD_NUM_RULE_STYLE("^[\\w-{}() +?.:$\"]{1,256}$"),
    STORE_FIELD_TYPE_STYLE("^BACKEND|FRONTEND|ALL$"),
    PAGE_SIZE_STYLE("^100$|^([1-9]|[1-9]\\d)$");

    private final String style;

    BkStyleEnum(String style) {
        this.style = style;
    }

    public String getStyle() {
        return style;
    }
}
