package cd.casic.ci.common.pipeline.pojo.agent;

import cd.casic.ci.common.pipeline.type.DispatchType;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.Getter;
import lombok.Setter;

import java.util.Map;

/**
 * @Author：mianbin
 * @Package：cd.casic.ci.common.pipeline.type.agent
 * @Project：ops-pro
 * @name：ThirdPartyAgentDispatch
 * @Date：2025/03/27 10:47
 * @Filename：ThirdPartyAgentDispatch
 * @description：Todo
 */
@Getter
@Setter
@AllArgsConstructor
@JsonIgnoreProperties(ignoreUnknown = true)
public abstract class ThirdPartyAgentDispatch extends DispatchType {
    private String value;
    private AgentType agentType;
    private String workspace;
    private ThirdPartyAgentDockerInfo dockerInfo;
    private ReusedInfo reusedInfo;


    public boolean idType() {
        return (agentType == AgentType.ID) || (reusedInfo != null && reusedInfo.getAgentType() == AgentType.ID) ||
                (agentType == AgentType.REUSE_JOB_ID && reusedInfo == null);
    }

    public boolean hasReuseMutex() {
        return this.agentType.isReuse() || this.reusedInfo != null;
    }

    public boolean isEnv() {
        return this instanceof ThirdPartyAgentEnvDispatchType;
    }

    public boolean isSingle() {
        return this instanceof ThirdPartyAgentIDDispatchType;
    }

    @Override
    public abstract void replaceField(Map<String, String> variables);

    @Override
    public abstract void cleanDataBeforeSave();

    @Data
    @AllArgsConstructor
    @JsonIgnoreProperties(ignoreUnknown = true)
    class ReusedInfo {
        private final String value;
        private final AgentType agentType;
        private final String jobId;
    }
}
