package cd.casic.ci.common.pipeline.type;


import cd.casic.ci.common.pipeline.pojo.OS;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.List;

/**
 * @Author：mianbin
 * @Package：cd.casic.ci.common.pipeline.type
 * @Project：ops-pro
 * @name：BuildType
 * @Date：2025/03/27 10:45
 * @Filename：BuildType
 * @description：Todo
 */
@Getter
@AllArgsConstructor
public enum BuildType {
    ESXI("公共构建资源", List.of(OS.MACOS), false, false, false),
    MACOS("云托管: MacOS on DevCloud", List.of(OS.MACOS), false, false, false),
    WINDOWS("云托管：Windows on DevCloud", List.of(OS.WINDOWS), false, false, false),
    KUBERNETES("Kubernetes构建资源", List.of(OS.LINUX), false, false, false),
    PUBLIC_DEVCLOUD("公共：Docker on DevCloud", List.of(OS.LINUX), true, false, false),
    PUBLIC_BCS("公共：Docker on Bcs", List.of(OS.LINUX), false, false, false),
    THIRD_PARTY_AGENT_ID("私有：单构建机", List.of(OS.MACOS, OS.LINUX, OS.WINDOWS), false, true, true),
    THIRD_PARTY_AGENT_ENV("私有：构建集群", List.of(OS.MACOS, OS.LINUX, OS.WINDOWS), false, true, true),
    THIRD_PARTY_PCG("PCG公共构建资源", List.of(OS.LINUX), false, false, false),
    THIRD_PARTY_DEVCLOUD("腾讯自研云（云devnet资源）", List.of(OS.LINUX), false, false, false),
    GIT_CI("工蜂CI", List.of(OS.LINUX), false, false, false),
    DOCKER("Docker公共构建机", List.of(OS.LINUX), true, true, true),
    STREAM("stream", List.of(OS.LINUX), false, false, false),
    AGENT_LESS("无编译环境", List.of(OS.LINUX), false, false, false);

    private final String value;
    private final List<OS> osList;
    private final boolean enableApp;
    private final boolean clickable;
    private final boolean visible;
}
