package cd.casic.pipeline.dispatch.pojo.thirdpartyagent;


import cd.casic.ci.common.pipeline.pojo.agent.DockerOptions;
import cd.casic.ci.common.pipeline.pojo.agent.ThirdPartyAgentDockerInfoDispatch;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author by mianbin
 * @Classname ThirdPartyBuildDockerInfo
 * @Description TODO
 * @Date 2025/4/8 16:27
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class ThirdPartyBuildDockerInfo {
    private String agentId;
    private String secretKey;
    private String image;
    private ThirdPartyBuildDockerInfoCredential credential;
    private DockerOptions options;
    private String imagePullPolicy;

    public ThirdPartyBuildDockerInfo(ThirdPartyAgentDockerInfoDispatch input) {
        this.agentId = input.getAgentId();
        this.secretKey = input.getSecretKey();
        this.image = input.getImage();
        this.credential = new ThirdPartyBuildDockerInfoCredential(input.getCredential());
        this.options = input.getOptions();
        this.imagePullPolicy = input.getImagePullPolicy();
    }
}
