package cd.casic.ci.process.process.service.target;

import cd.casic.ci.common.pipeline.req.target.TargetManagerCreateReq;
import cd.casic.ci.common.pipeline.req.target.TargetManagerUpdateReq;
import cd.casic.ci.common.pipeline.req.target.TargetQueryReq;
import cd.casic.ci.common.pipeline.resp.target.TargetManagerResp;
import cd.casic.ci.common.pipeline.utils.PageResult;
import cd.casic.ci.process.process.dataObject.base.BaseIdReq;
import cd.casic.ci.process.process.dataObject.target.TargetManager;
import com.baomidou.mybatisplus.extension.service.IService;
import jakarta.validation.Valid;

import java.util.List;

/**
 * @author HopeLi
 * @version v1.0
 * @ClassName TargetManagerService
 * @Date: 2025/5/17 10:20
 * @Description:
 */
public interface TargetManagerService extends IService<TargetManager> {
    void createTarget(@Valid TargetManagerCreateReq req);

    void updateTarget(@Valid TargetManagerUpdateReq req);

    void deleteTarget(@Valid BaseIdReq req);

    PageResult<TargetManagerResp> findTargetPage(@Valid TargetQueryReq query);

    List<TargetManagerResp> findTargetList(@Valid TargetQueryReq query);
}
