package cd.casic.pipeline.store.api.image;

import cd.casic.framework.commons.pojo.CommonResult;
import cd.casic.pipeline.store.pojo.image.request.ImageBaseInfoUpdateRequest;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.web.bind.annotation.*;

import static cd.casic.ci.common.pipeline.constant.OpsHeader.AUTH_HEADER_USER_ID;

@Tag(name = "BUILD_MARKET_IMAGE", description = "镜像市场-镜像")
@RestController
@RequestMapping("/build/market/image")
public interface BuildImageResource {

    @Operation(summary = "更新镜像信息")
    @PutMapping("/projectCodes/{projectCode}/imageCodes/{imageCode}/versions/{version}")
    CommonResult<Boolean> updateImageBaseInfo(
        @Parameter(description = "用户ID", required = true)
        @RequestHeader(AUTH_HEADER_USER_ID)
        String userId,
        @Parameter(description = "项目代码", required = true)
        @PathVariable("projectCode")
        String projectCode,
        @Parameter(description = "镜像标识", required = true)
        @PathVariable("imageCode")
        String imageCode,
        @Parameter(description = "版本号", required = true)
        @PathVariable("version")
        String version,
        @Parameter(description = "镜像基本信息修改请求报文体", required = true)
        ImageBaseInfoUpdateRequest imageBaseInfoUpdateRequest
    );
}