package cd.casic.pipeline.store.pojo.common.category;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import java.util.HashMap;
import java.util.Map;

@Data
@Schema(title = "范畴信息")
public class Category {
    @Schema(title = "范畴ID", required = true)
    private String id;
    @Schema(title = "范畴代码", required = true)
    private String categoryCode;
    @Schema(title = "范畴名称", required = true)
    private String categoryName;
    @Schema(title = "范畴附加属性配置表", required = true)
    private Map<String, String> settings = new HashMap<>();
    @Schema(title = "icon地址", required = false)
    private String iconUrl;
    @Schema(title = "类别 ATOM:插件 TEMPLATE:模板 IMAGE:镜像 IDE_ATOM:IDE插件", required = true)
    private String categoryType;
    @Schema(title = "创建日期")
    private Long createTime = 0L;
    @Schema(title = "更新日期")
    private Long updateTime = 0L;
}