package cd.casic.pipeline.store.pojo.image.request;

import cd.casic.pipeline.store.pojo.image.enums.ImageRDTypeEnum;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

@Data
public class ApproveImageReq {
    @Schema(title = "镜像标识")
    private String imageCode;
    
    @Schema(title = "是否为公共镜像")
    private Boolean publicFlag;
    
    @Schema(title = "是否推荐")
    private Boolean recommendFlag;
    
    @Schema(title = "是否为官方认证")
    private Boolean certificationFlag;
    
    @Schema(title = "研发来源 SELF_DEVELOPED：自研 THIRD_PARTY：第三方", required = false)
    private ImageRDTypeEnum rdType;
    
    @Schema(title = "权重（数值越大代表权重越高）")
    private Integer weight;
    
    @Schema(title = "审核结果：PASS：通过|REJECT：驳回")
    private String result;
    
    @Schema(title = "审核结果说明")
    private String message;
}