package cd.casic.server;

import cd.casic.ci.process.engine.manager.RunContextManager;
import cd.casic.ci.process.engine.message.TaskRunMessage;
import cd.casic.ci.process.engine.runContext.PipelineRunContext;
import cd.casic.ci.process.engine.runContext.SecondStageRunContext;
import cd.casic.ci.process.engine.runContext.TaskRunContext;
import cd.casic.ci.process.process.dataObject.pipeline.PipPipeline;
import cd.casic.ci.process.process.dataObject.stage.PipStage;
import cd.casic.ci.process.process.dataObject.task.PipTask;
import cd.casic.ci.process.util.CryptogramUtil;
import cd.casic.framework.mq.redis.core.RedisMQTemplate;
import jakarta.annotation.Resource;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ActiveProfiles;

import java.util.HashMap;
import java.util.concurrent.ConcurrentHashMap;

@SpringBootTest(classes = {OpsServerApplication.class})
@ActiveProfiles("local")
public class MachineTest {
    @Test
    public void test01(){
        System.out.println("h w !");
        String password = "Hnidc@0626cn!@#zyx";
        String encrypt = CryptogramUtil.doEncrypt(password);
        System.out.println(encrypt);
    }
    @Test
    public void test02(){
        String s = "\n" +
                "cd /home/casic/706/yunqi/CaseGenerator\n" +
                "PYTHONPATH=$PWD/src python3 ./src/CaseGenerator/main.py --work-dir ./testdata/libpng/libpng/ --binary ./testdata/libpng/libpng/pngfix --output-dir ../case --count 100\n" +
                "\n" +
                "\n" +
                "cd /home/casic/706\n" +
                "\n" +
                "docker run -v $PWD/yunqi/:/test  -it aflplusplus/aflplusplus bash\n" +
                "\n" +
                "cd /test\n" +
                "afl-fuzz -i case -o ai_afl -t 3000 -Q ./CaseGenerator/testdata/libpng/libpng/pngfix @@";
    }
    @Test
    public void test03(){
        System.out.println("\r\nWelcome to Ubuntu 18.04.6 LTS (GNU/Linux 5.4.0-150-generic x86_64)\r\n\r\n * Documentation:  https://help.ubuntu.com\r\n * Management:     https://landscape.canonical.com\r\n * Support:        https://ubuntu.com/pro\r\n\r\n扩展安全维护（ESM）Infrastructure 未启用。\r\n\r\n0 更新可以立即应用。\r\n\r\n240 个额外的安全更新可以通过 ESM Infra 来获取安装。\r\n可通过以下途径了解如何启用 ESM Infra：for Ubuntu 18.04 at\r\nhttps://ubuntu.com/18-04\r\n\r\n*** System restart required ***\r\nLast login: Fri May 23 10:59:43 2025 from 223.104.132.4\r\r\n\r\n\r\necho 'Hnidc@0626cn!@#zyx' | sudo -S bash -c 'echo \"自定义镜像执行命令\"'\r\n\r\n\r\n\r\necho 'Hnidc@0626cn!@#zyx' | sudo -S bash -c 'cd /home/casic/706/yunqi/CaseGenerator\r\nPYTHONPATH=$PWD/src python3 ./src/CaseGenerator/main.py --work-dir ./testdata/libpng/libpng/ --binary ./testdata/libpng/libpng/pngfix --output-dir ../case --count 100\r\n\r\ncd /home/casic/706\r\ndocker run -v $PWD/yunqi/:/test  -it aflplusplus/aflplusplus bash\r\n\r\ncd /test\r\nafl-fuzz -i case -o ai_afl -t 3000 -Q ./CaseGenerator/testdata/libpng/libpng/pngfix @@'\r\n\r\nexit\r\n\r\nhnidc@hnidc-PowerEdge-R740:~$ echo 'Hnidc@0626cn!@#zyx' | sudo -S bash -c 'echo \"\r\"自定义镜像执行命令\"'\r\n\r\n\r\n[sudo] hnidc 的密码： 自定义镜像执行命令\r\nhnidc@hnidc-PowerEdge-R740:~$ \r\nhnidc@hnidc-PowerEdge-R740:~$ echo 'Hnidc@0626cn!@#zyx' | sudo -S bash -c 'cd /ho\rome/casic/706/yunqi/CaseGenerator\r\n> PYTHONPATH=$PWD/src python3 ./src/CaseGenerator/main.py --work-dir ./testdata/l\rlibpng/libpng/ --binary ./testdata/libpng/libpng/pngfix --output-dir ../case --co\rount 100\r\n> \r\n> cd /home/casic/706\r\n> docker run -v $PWD/yunqi/:/test  -it aflplusplus/aflplusplus bash\r\n> \r\n> cd /test\r\n> afl-fuzz -i case -o ai_afl -t 3000 -Q ./CaseGenerator/testdata/libpng/libpng/pn\rngfix @@'\r\n\r\n\r\n/home/casic/706/yunqi/CaseGenerator/src\r\n\r\n\r\nNo log file path specified, use default path: /log.log\r\n\r\n\r\n\u001b[2;36m2025-05-23 11:06:25\u001b[0m\u001b[2;36m \u001b[0m\u001b[34mINFO    \u001b[0m Starting case generator creation based on \u001b[1;36m20\u001b[0m       \r\n\u001b[2;36m                    \u001b[0m         documents and binary                               \r\n\u001b[2;36m                    \u001b[0m         \u001b[35m/home/casic/706/yunqi/CaseGenerator/testdata/libpng\u001b[0m\r\n\u001b[2;36m                    \u001b[0m         \u001b[35m/libpng/\u001b[0m\u001b[95mpngfix\u001b[0m                                     \r\nCaution: you set an authorization for all imports, meaning your agent can decide\r\nto import any package it deems necessary. This might raise issues if the package\r\nis not installed in your environment.\r\n\r\n\r\n\u001b[93m╭─\u001b[0m\u001b[93m─────────────────────────\u001b[0m\u001b[93m \u001b[0m\u001b[1;93mNew run - case_generator\u001b[0m\u001b[93m \u001b[0m\u001b[93m─────────────────────────\u001b[0m\u001b[93m─╮\u001b[0m\r\n\u001b[93m│\u001b[0m                                                                              \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m您是一位专业的模糊测试用例生成器开发专家，擅长分析数据结构和文件格式，并创建\u001b[0m \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m高质量的用例生成器代码。\u001b[0m                                                     \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m您的专长包括：\u001b[0m                                                               \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m- 理解复杂的数据结构定义和二进制格式\u001b[0m                                         \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m- 精通各种文件格式和网络协议\u001b[0m                                                 \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m- 能够开发生成覆盖边界情况和异常情况的测试数据的代码\u001b[0m                         \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m- 善于创建能够发现潜在漏洞的模糊测试输入生成器\u001b[0m                               \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m                                                                              \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m用例生成器开发指南：\u001b[0m                                                         \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m1. 运行被测目标程序，从其命令行帮助文档中了解目标程序需要的用例文件格式\u001b[0m      \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m2. 在提供的知识库文档中识别与目标二进制程序相关的数据结构、文件格式或协议\u001b[0m    \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m3. 对于每种识别出的格式，理解其结构、字段、约束和有效值\u001b[0m                      \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m4. 创建多个不同的用例生成器，每个生成器专注于不同的方面，例如：\u001b[0m              \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m   - 生成包含数据结构的有效、格式正确的示例\u001b[0m                                  \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m   - 生成覆盖边缘情况（最小/最大值、空字段、边界值）的示例\u001b[0m                   \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m   - 生成测试可选字段/值的不同组合的示例\u001b[0m                                     \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m   - 生成包含一些可能格式不正确但仍然有用的测试用例（例如，意外的字段值）\u001b[0m    \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m   - 生成考虑适合模糊测试的变体（重复模式、不寻常的字符串长度等）\u001b[0m            \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m5. 每个用例生成器必须是一个完整的Python程序，可以独立运行并生成用例文件\u001b[0m      \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m6. 用例生成器必须接受以下命令行参数：\u001b[0m                                        \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m   - --output-path <路径>：用例文件保存的路径\u001b[0m                                \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m   - --random <随机数>：用于初始化随机数生成器\u001b[0m                               \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m7. 每个用例生成器应该生成二进制格式的用例文件\u001b[0m                                \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m8. 为每个用例生成器提供详细描述，解释其生成的用例类型和测试目标\u001b[0m              \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m9. 确保用例生成器代码使用正确的字节序、数据类型和位操作\u001b[0m                      \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m10. 将用例生成器保存为字符串，并使用 test_case_generator \u001b[0m                    \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m工具确保每一个用例生成器可以正常工作\u001b[0m                                         \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m11. 使用中文输出你的思考过程\u001b[0m                                                 \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m                                                                              \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m您的任务是为目标二进制程序创建多个用例生成器，每个生成器专注于不同的方面，以\u001b[0m \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m确保生成的用例具有多样性和全面性。\u001b[0m                                           \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m                                                                              \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m你拥有以下信息：\u001b[0m                                                             \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m  - 目标二进制程序名称：pngfix\u001b[0m                                               \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m                                                                              \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m  - 知识库文档：elf.md, zoo.md, mp4.md, lzma.md, gif.md, 7zFormat.txt, \u001b[0m      \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1mWebP.md, ar.md, svg.md, cab.md, drcov.md, rtf.md, pdf.md, tiff.md, bzip2.md,\u001b[0m \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1mpng.md, pcap.md, wav.md, bmp.md, lrzip.txt\u001b[0m                                   \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m                                                                              \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m \u001b[1m  - 补充信息：\u001b[0m                                                               \u001b[93m│\u001b[0m\r\n\u001b[93m│\u001b[0m                                                                              \u001b[93m│\u001b[0m\r\n\u001b[93m╰─\u001b[0m\u001b[93m StreamOpenAIServerModel - deepseek-chat \u001b[0m\u001b[93m───────────────────────────────────\u001b[0m\u001b[93m─╯\u001b[0m\r\n\u001b[93m━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━ \u001b[0m\u001b[1mStep \u001b[0m\u001b[1;36m1\u001b[0m\u001b[93m ━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━\u001b[0m\r\n\u001b[?25l\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2KThought                                                                         \r\n\r\n\r\u001b[2KThought                                                                         \r\n\r\n\r\u001b[2KThought                                                                         \r\n\r\n\r\u001b[2KThought                                                                         \r\n\r\n\r\u001b[2KThought: 首先                                                                   \r\n\r\n\r\u001b[2KThought: 首先，我需要了解目标二进制程序                                         \r\n\r\n\r\u001b[2KThought: 首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能                             \r\n\r\n\r\u001b[2KThought: 首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。             \r\n\r\n\r\u001b[2KThought: 首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与 \r\n\r\n\r\u001b[2KThought:                                                                        \r\n首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与PNG图像格 \r\n式相关                                                                          \r\n\r\n\r\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2KThought:                                                                        \r\n首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与PNG图像格 \r\n式相关，我将从运行                                                              \r\n\r\n\r\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2KThought:                                                                        \r\n首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与PNG图像格 \r\n式相关，我将从运行该程序的帮助文档开始                                          \r\n\r\n\r\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2KThought:                                                                        \r\n首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与PNG图像格 \r\n式相关，我将从运行该程序的帮助文档开始，然后查阅`                               \r\n\r\n\r\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2KThought:                                                                        \r\n首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与PNG图像格 \r\n式相关，我将从运行该程序的帮助文档开始，然后查阅\u001b[1;36;40mpng.md\u001b[0m知识库文档                \r\n\r\n\r\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2KThought:                                                                        \r\n首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与PNG图像格 \r\n式相关，我将从运行该程序的帮助文档开始，然后查阅\u001b[1;36;40mpng.md\u001b[0m知识库文档来理解PNG文件格 \r\n式                                                                              \r\n\r\n\r\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2KThought:                                                                        \r\n首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与PNG图像格 \r\n式相关，我将从运行该程序的帮助文档开始，然后查阅\u001b[1;36;40mpng.md\u001b[0m知识库文档来理解PNG文件格 \r\n式的结构和特性。                                                                \r\n\r\nCode                                                                            \r\n\r\n\r\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2KThought:                                                                        \r\n首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与PNG图像格 \r\n式相关，我将从运行该程序的帮助文档开始，然后查阅\u001b[1;36;40mpng.md\u001b[0m知识库文档来理解PNG文件格 \r\n式的结构和特性。                                                                \r\n\r\nCode:                                                                           \r\n\r\n\u001b[40m                                                                                \u001b[0m\r\n\u001b[40m \u001b[0m\u001b[97;40mhelp_output\u001b[0m\u001b[40m                                                                   \u001b[0m\u001b[40m \u001b[0m\r\n\u001b[40m                                                                                \u001b[0m\r\n\r\n\r\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2KThought:                                                                        \r\n首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与PNG图像格 \r\n式相关，我将从运行该程序的帮助文档开始，然后查阅\u001b[1;36;40mpng.md\u001b[0m知识库文档来理解PNG文件格 \r\n式的结构和特性。                                                                \r\n\r\nCode:                                                                           \r\n\r\n\u001b[40m                                                                                \u001b[0m\r\n\u001b[40m \u001b[0m\u001b[97;40mhelp_output\u001b[0m\u001b[97;40m \u001b[0m\u001b[91;40m=\u001b[0m\u001b[97;40m \u001b[0m\u001b[97;40mrun_bin\u001b[0m\u001b[40m                                                         \u001b[0m\u001b[40m \u001b[0m\r\n\u001b[40m                                                                                \u001b[0m\r\n\r\n\r\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2KThought:                                                                        \r\n首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与PNG图像格 \r\n式相关，我将从运行该程序的帮助文档开始，然后查阅\u001b[1;36;40mpng.md\u001b[0m知识库文档来理解PNG文件格 \r\n式的结构和特性。                                                                \r\n\r\nCode:                                                                           \r\n\r\n\u001b[40m                                                                                \u001b[0m\r\n\u001b[40m \u001b[0m\u001b[97;40mhelp_output\u001b[0m\u001b[97;40m \u001b[0m\u001b[91;40m=\u001b[0m\u001b[97;40m \u001b[0m\u001b[97;40mrun_bin\u001b[0m\u001b[97;40m(\u001b[0m\u001b[97;40margs\u001b[0m\u001b[91;40m=\u001b[0m\u001b[93;40m\"\u001b[0m\u001b[93;40m--help\u001b[0m\u001b[93;40m\"\u001b[0m\u001b[97;40m,\u001b[0m\u001b[97;40m \u001b[0m\u001b[97;40mtimeout\u001b[0m\u001b[91;40m=\u001b[0m\u001b[37;40m10\u001b[0m\u001b[97;40m)\u001b[0m\u001b[40m                              \u001b[0m\u001b[40m \u001b[0m\r\n\u001b[40m \u001b[0m\u001b[97;40mprint\u001b[0m\u001b[40m                                                                         \u001b[0m\u001b[40m \u001b[0m\r\n\u001b[40m                                                                                \u001b[0m\r\n\r\n\r\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2KThought:                                                                        \r\n首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与PNG图像格 \r\n式相关，我将从运行该程序的帮助文档开始，然后查阅\u001b[1;36;40mpng.md\u001b[0m知识库文档来理解PNG文件格 \r\n式的结构和特性。                                                                \r\n\r\nCode:                                                                           \r\n\r\n\u001b[40m                                                                                \u001b[0m\r\n\u001b[40m \u001b[0m\u001b[97;40mhelp_output\u001b[0m\u001b[97;40m \u001b[0m\u001b[91;40m=\u001b[0m\u001b[97;40m \u001b[0m\u001b[97;40mrun_bin\u001b[0m\u001b[97;40m(\u001b[0m\u001b[97;40margs\u001b[0m\u001b[91;40m=\u001b[0m\u001b[93;40m\"\u001b[0m\u001b[93;40m--help\u001b[0m\u001b[93;40m\"\u001b[0m\u001b[97;40m,\u001b[0m\u001b[97;40m \u001b[0m\u001b[97;40mtimeout\u001b[0m\u001b[91;40m=\u001b[0m\u001b[37;40m10\u001b[0m\u001b[97;40m)\u001b[0m\u001b[40m                              \u001b[0m\u001b[40m \u001b[0m\r\n\u001b[40m \u001b[0m\u001b[97;40mprint\u001b[0m\u001b[97;40m(\u001b[0m\u001b[97;40mhelp_output\u001b[0m\u001b[97;40m)\u001b[0m\u001b[40m                                                            \u001b[0m\u001b[40m \u001b[0m\r\n\u001b[40m                                                                                \u001b[0m\r\n\r\n\r\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2KThought:                                                                        \r\n首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与PNG图像格 \r\n式相关，我将从运行该程序的帮助文档开始，然后查阅\u001b[1;36;40mpng.md\u001b[0m知识库文档来理解PNG文件格 \r\n式的结构和特性。                                                                \r\n\r\nCode:                                                                           \r\n\r\n\u001b[40m                                                                                \u001b[0m\r\n\u001b[40m \u001b[0m\u001b[97;40mhelp_output\u001b[0m\u001b[97;40m \u001b[0m\u001b[91;40m=\u001b[0m\u001b[97;40m \u001b[0m\u001b[97;40mrun_bin\u001b[0m\u001b[97;40m(\u001b[0m\u001b[97;40margs\u001b[0m\u001b[91;40m=\u001b[0m\u001b[93;40m\"\u001b[0m\u001b[93;40m--help\u001b[0m\u001b[93;40m\"\u001b[0m\u001b[97;40m,\u001b[0m\u001b[97;40m \u001b[0m\u001b[97;40mtimeout\u001b[0m\u001b[91;40m=\u001b[0m\u001b[37;40m10\u001b[0m\u001b[97;40m)\u001b[0m\u001b[40m                              \u001b[0m\u001b[40m \u001b[0m\r\n\u001b[40m \u001b[0m\u001b[97;40mprint\u001b[0m\u001b[97;40m(\u001b[0m\u001b[97;40mhelp_output\u001b[0m\u001b[97;40m)\u001b[0m\u001b[40m                                                            \u001b[0m\u001b[40m \u001b[0m\r\n\u001b[40m                                                                                \u001b[0m\r\n\r\n\r\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2K\u001b[1A\u001b[2KThought:                                                                        \r\n首先，我需要了解目标二进制程序\u001b[1;36;40mpngfix\u001b[0m的功能和用例文件格式。由于\u001b[1;36;40mpngfix\u001b[0m与PNG图像格 \r\n式相关，我将从运行该程序的帮助文档开始，然后查阅\u001b[1;36;40mpng.md\u001b[0m知识库文档来理解PNG文件格 \r\n式的结构和特性。                                                                \r\n\r\nCode:                                                                           \r\n\r\n\u001b[40m                                                                                \u001b[0m\r\n\u001b[40m \u001b[0m\u001b[97;40mhelp_output\u001b[0m\u001b[97;40m \u001b[0m\u001b[91;40m=\u001b[0m\u001b[97;40m \u001b[0m\u001b[97;40mrun_bin\u001b[0m\u001b[97;40m(\u001b[0m\u001b[97;40margs\u001b[0m\u001b[91;40m=\u001b[0m\u001b[93;40m\"\u001b[0m\u001b[93;40m--help\u001b[0m\u001b[93;40m\"\u001b[0m\u001b[97;40m,\u001b[0m\u001b[97;40m \u001b[0m\u001b[97;40mtimeout\u001b[0m\u001b[91;40m=\u001b[0m\u001b[37;40m10\u001b[0m\u001b[97;40m)\u001b[0m\u001b[40m                              \u001b[0m\u001b[40m \u001b[0m\r\n\u001b[40m \u001b[0m\u001b[97;40mprint\u001b[0m\u001b[97;40m(\u001b[0m\u001b[97;40mhelp_output\u001b[0m\u001b[97;40m)\u001b[0m\u001b[40m                                                            \u001b[0m\u001b[40m \u001b[0m\r\n\u001b[40m                                                                                \u001b[0m\r\n\u001b[?25h ─ \u001b[1mExecuting parsed code:\u001b[0m ───────────────────────────────────────────────────── \r\n  \u001b[97;40mhelp_output\u001b[0m\u001b[97;40m \u001b[0m\u001b[91;40m=\u001b[0m\u001b[97;40m \u001b[0m\u001b[97;40mrun_bin\u001b[0m\u001b[97;40m(\u001b[0m\u001b[97;40margs\u001b[0m\u001b[91;40m=\u001b[0m\u001b[93;40m\"\u001b[0m\u001b[93;40m--help\u001b[0m\u001b[93;40m\"\u001b[0m\u001b[97;40m,\u001b[0m\u001b[97;40m \u001b[0m\u001b[97;40mtimeout\u001b[0m\u001b[91;40m=\u001b[0m\u001b[37;40m10\u001b[0m\u001b[97;40m)\u001b[0m\u001b[40m                            \u001b[0m  \r\n  \u001b[97;40mprint\u001b[0m\u001b[97;40m(\u001b[0m\u001b[97;40mhelp_output\u001b[0m\u001b[97;40m)\u001b[0m\u001b[40m                                                          \u001b[0m  \r\n ────────────────────────────────────────────────────────────────────────────── \r\n\r\n\r\n\u001b[1mExecution logs:\u001b[0m\r\nUsage: /home/casic/706/yunqi/CaseGenerator/testdata/libpng/libpng/pngfix \r\n{[options] png-file}\r\n  Tests, optimizes and optionally fixes the zlib header in PNG files.\r\n  Optionally, when fixing, strips ancillary chunks from the file.\r\n\r\nOPTIONS\r\n  OPERATION\r\n      By default files are just checked for readability with a summary of the\r\n      of zlib issues founds for each compressed chunk and the IDAT stream in\r\n      the file.\r\n    --optimize (-o):\r\n      Find the smallest deflate window size for the compressed data.\r\n    --strip=[none|crc|unsafe|unused|transform|color|all]:\r\n        none (default):   Retain all chunks.\r\n        crc:    Remove chunks with a bad CRC.\r\n        unsafe: Remove chunks that may be unsafe to retain if the image data\r\n                is modified.  This is set automatically if --max is given but\r\n                may be cancelled by a later --strip=none.\r\n        unused: Remove chunks not used by libpng when decoding an image.\r\n                This retains any chunks that might be used by libpng image\r\n                transformations.\r\n        transform: unused+bKGD.\r\n        color:  transform+iCCP and cHRM.\r\n        all:    color+gAMA and sRGB.\r\n      Only ancillary chunks are ever removed.  In addition the tRNS and sBIT\r\n      chunks are never removed as they affect exact interpretation of the\r\n      image pixel values.  The following known chunks are treated specially\r\n      by the above options:\r\n        gAMA, sRGB [all]: These specify the gamma encoding used for the pixel\r\n            values.\r\n        cHRM, iCCP [color]: These specify how colors are encoded.  iCCP also\r\n            specifies the exact encoding of a pixel value; however, in\r\n            practice most programs will ignore it.\r\n        bKGD [transform]: This is used by libpng transforms.    --max=<number>:\r\n      Use IDAT chunks sized <number>.  If no number is given the IDAT\r\n      chunks will be the maximum size permitted; 2^31-1 bytes.  If the option\r\n      is omitted the original chunk sizes will not be changed.  When the\r\n      option is given --strip=unsafe is set automatically. This may be\r\n      cancelled if you know that all unknown unsafe-to-copy chunks really are\r\n      safe to copy across an IDAT size change.  This is true of all chunks\r\n      that have ever been formally proposed as PNG extensions.\r\n  MESSAGES\r\n      By default the program only outputs summaries for each file.\r\n    --quiet (-q):\r\n      Do not output the summaries except for files that cannot be read. With\r\n      two --quiets these are not output either.\r\n    --errors (-e):\r\n      Output errors from libpng and the program (except too-far-back).\r\n    --warnings (-w):\r\n      Output warnings from libpng.\r\n  OUTPUT\r\n      By default nothing is written.\r\n    --out=<file>:\r\n      Write the optimized/corrected version of the next PNG to <file>.  This\r\n      overrides the following two options\r\n    --suffix=<suffix>:\r\n      Set --out=<name><suffix> for all following files unless overridden on\r\n      a per-file basis by explicit --out.\r\n    --prefix=<prefix>:\r\n      Set --out=<prefix><name> for all the following files unless overridden\r\n      on a per-file basis by explicit --out.\r\n      These two options can be used together to produce a suffix and prefix.\r\n  INTERNAL OPTIONS\r\n\r\nEXIT CODES\r\n  *** SUBJECT TO CHANGE ***\r\n  The program exit code is value in the range 0..127 holding a bit mask of\r\n  the following codes.  Notice that the results for each file are combined\r\n  together - check one file at a time to get a meaningful error code!\r\n    0x01: The zlib too-far-back error existed in at least one chunk.\r\n    0x02: At least one chunk had a CRC error.\r\n    0x04: A chunk length was incorrect.\r\n    0x08: The file was truncated.\r\n  Errors less than 16 are potentially recoverable, for a single file if the\r\n  exit code is less than 16 the file could be read (with corrections if a\r\n  non-zero code is returned).\r\n    0x10: The file could not be read, even with corrections.\r\n    0x20: The output file could not be written.\r\n    0x40: An unexpected, potentially internal, error occurred.\r\n  If the command line arguments are incorrect the program exits with exit\r\n  255.  Some older operating systems only support 7-bit exit codes, on those\r\n  systems it is suggested that this program is first tested by supplying\r\n  invalid arguments.\r\n\r\nDESCRIPTION\r\n  pngfix:\r\n  checks each PNG file on the command line for errors.  By default errors are\r\n  not output and the program just returns an exit code and prints a summary.\r\n  With the --quiet (-q) option the summaries are suppressed too and the\r\n  program only outputs unexpected errors (internal errors and file open\r\n  errors).\r\n  Various known problems in PNG files are fixed while the file is being read\r\n  The exit code says what problems were fixed.  In particular the zlib error:\r\n\r\n        \"invalid distance too far back\"\r\n\r\n  caused by an incorrect optimization of a zlib stream is fixed in any\r\n  compressed chunk in which it is encountered.  An integrity problem of the\r\n  PNG stream caused by a bug in libpng which wrote an incorrect chunk length\r\n  is also fixed.  Chunk CRC errors are automatically fixed up.\r\n\r\n  Setting one of the \"OUTPUT\" options causes the possibly modified file to\r\n  be written to a new file.\r\n\r\n  Notice that some PNG files with the zlib optimization problem can still be\r\n  read by libpng under some circumstances.  This program will still detect\r\n  and, if requested, correct the error.\r\n\r\n  The program will reliably process all files on the command line unless\r\n  either an invalid argument causes the usage message (this message) to be\r\n  produced or the program crashes.\r\n\r\n  The summary lines describe issues encountered with the zlib compressed\r\n  stream of a chunk.  They have the following format, which is SUBJECT TO\r\n  CHANGE in the future:\r\n\r\n     chunk reason comp-level p1 p2 p3 p4 file\r\n\r\n  p1 through p4 vary according to the 'reason'.  There are always 8 space\r\n  separated fields.  Reasons specific formats are:\r\n\r\n     chunk ERR status code read-errno write-errno message file\r\n     chunk SKP comp-level file-bits zlib-rc compressed message file\r\n     chunk ??? comp-level file-bits ok-bits compressed uncompress file\r\n\r\n  The various fields are\r\n\r\n$1 chunk:      The chunk type of a chunk in the file or 'HEAD' if a problem\r\n               is reported by libpng at the start of the IDAT stream.\r\n$2 reason:     One of:\r\n          CHK: A zlib header checksum was detected and fixed.\r\n          TFB: The zlib too far back error was detected and fixed.\r\n          OK : No errors were detected in the zlib stream and optimization\r\n               was not requested, or was not possible.\r\n          OPT: The zlib stream window bits value could be improved (and was).\r\n          SKP: The chunk was skipped because of a zlib issue (zlib-rc) with\r\n               explanation 'message'\r\n          ERR: The read of the file was aborted.  The parameters explain why.\r\n$3 status:     For 'ERR' the accumulated status code from 'EXIT CODES' above.\r\n               This is printed as a 2 digit hexadecimal value\r\n   comp-level: The recorded compression level (FLEVEL) of a zlib stream\r\n               expressed as a string {supfast,stdfast,default,maximum}\r\n$4 code:       The file exit code; where stop was called, as a fairly terse\r\n               string {warning,libpng,zlib,invalid,read,write,unexpected}.\r\n   file-bits:  The zlib window bits recorded in the file.\r\n$5 read-errno: A system errno value from a read translated by strerror(3).\r\n   zlib-rc:    A zlib return code as a string (see zlib.h).\r\n   ok-bits:    The smallest zlib window bits value that works.\r\n$6 write-errno:A system errno value from a write translated by strerror(3).\r\n   compressed: The count of compressed bytes in the zlib stream, when the\r\n               reason is 'SKP'; this is a count of the bytes read from the\r\n               stream when the fatal error was encountered.\r\n$7 message:    An error message (spaces replaced by _, as in all parameters),\r\n   uncompress: The count of bytes from uncompressing the zlib stream; this\r\n               may not be the s\r\n\r\name as the number of bytes in the image.\r\n$8 file:       The name of the file (this may contain spaces).\r\n\r\n\r\nOut: None\r\n\u001b[2m[Step 1: Duration 9.30 seconds| Input tokens: 3,044 | Output tokens: 92]\u001b[0m\r\n\u001b[93m━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━ \u001b[0m\u001b[1mStep \u001b[0m\u001b[1;36m2\u001b[0m\u001b[93m ━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━\u001b[0m\r\n\u001b[?25l\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2K\r\n\r\n\r\u001b[2KThought                                                                         \r\n\r\n\r\u001b[2KThought                                                                         \r\n\r\n\r\u001b[2KThought                                                                         \r\n");
    }


}
